clc;clear;close all

%% signal & gap
[signal,fs] = greasy;
signal = signal(2501:3600);
N = length(signal);
s = 500 %gap start
f = 580 %gap finish

%% parameters
w = 256
a = 64
M = 64
% w = 1024
% a = 256
% M = 128
offset = 0
neig = 1; %neigbourhood (1...no group structure)


%% DGT of original
g = firwin('hann',w);
Fr = frame('dgtreal',g,a,M,'timeinv'); %'timeinv' ensures consistency of phases (long signal vs. short signal)

coefs = frana(Fr,signal);
coefs = framecoef2native(Fr,coefs); 

% plot spectrogram
f1 = figure;
maximum = max(max(abs(coefs)));
h1 = imagesc(abs(coefs),[0 maximum]);
axis xy
xlabel('time shift')
ylabel('frequency bin')

%% DGT of shortened
% Determine just the useful part w.r.t. gap
[q,Q,p,P,S,F,u,v,U,V,L] = min_sig_supp(w,a,M,s,f,N,1,offset)
Ssignal = signal(q:Q);

%compute DGT
Scoefs = frana(Fr,Ssignal);
Scoefs = framecoef2native(Fr,Scoefs);

% plot spectrogram
f2 = figure;
h2 = imagesc(abs(Scoefs),[0 maximum]); %the same scale as before
axis xy
xlabel('time shift')
ylabel('frequency bin')

%% Comparison of coefficients
%extract just the useful coefficients
coefs_useful = coefs(:,S:F);
Scoefs_useful = Scoefs(:,U:V);

Scoefs_useful-coefs_useful
norm(Scoefs_useful-coefs_useful,'fro')

%rectangle around useful coefs
figure(f1)
rectangle('Position',[S-.5,0,F-S+1,M],'LineWidth',2,'LineStyle','--','EdgeColor','y') %'EraseMode','xor')
figure(f2)
rectangle('Position',[U-.5,0,V-U+1,M],'LineWidth',2,'LineStyle','--','EdgeColor','y')  %'EraseMode','xor')

%neighbouring coefs are not identical
coefs(:,S-1) - Scoefs(:,U-1)
norm(coefs(:,S-1) - Scoefs(:,U-1),'fro')
coefs(:,F+1) - Scoefs(:,U+1)
norm(coefs(:,F+1) - Scoefs(:,U+1),'fro')


%% overlaps
overlaps = overlap(w,a,M,s,f,N)